SystemOrganization addCategory: #'OB-Enhancements-PackageBrower'!
SystemOrganization addCategory: #'OB-Enhancements-SmartGroup'!
SystemOrganization addCategory: #'OB-Enhancements-MultipleSelection'!
SystemOrganization addCategory: #'OB-Enhancements-Commands'!
SystemOrganization addCategory: #'OB-Enhancements-Morphs'!
SystemOrganization addCategory: #'OB-Enhancements-Panels'!

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 11:48'!
panel
	^panel ! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 14:54'!
preselectNodes! !

OBColumn subclass: #OBEnhancementColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBEnhancementColumn commentStamp: 'dr 7/20/2007 13:50' prior: 0!
I am the a slightly adapted version of OBColumn and I am used in all browser provided by the enhancements package.
!

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 7/20/2007 13:52'!
signalSelectionChanged
	super signalSelectionChanged.
	self next ifNotNil: [self next preselectNodes].! !

OBEnhancementColumn subclass: #OBMultipleSelectionColumn
	instanceVariableNames: 'multipleSelection oldSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionColumn methodsFor: 'building' stamp: 'dr 7/4/2007 15:51'!
buildOn: aBuilder
	^ aBuilder
		multipleSelectionColumn: self 
		with: [switch buildOn: aBuilder]! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 5/29/2007 14:56'!
clearSelection
	super clearSelection.
	multipleSelection := Dictionary new.! !

!OBMultipleSelectionColumn methodsFor: 'morphic' stamp: 'dr 7/4/2007 15:50'!
listMorph
	^ (OBPluggableListMorphOfMany
		on: self
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu: 
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: self dragEnabled;
			dropEnabled: self dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			adoptPaneColor: panel defaultBackgroundColor;
			yourself! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 5/29/2007 14:55'!
listSelectionAt: anIndex
	^multipleSelection at: anIndex ifAbsent: [^false]! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 11/30/2007 10:45'!
listSelectionAt: anIndex put: aValue 
     | isSelected |
     isSelected := multipleSelection at: anIndex ifAbsent: [false].

     "if we did not de-select the primary selection"
     (aValue not and: [anIndex = selection]) ifFalse: [
	     multipleSelection at: anIndex put: aValue.
          "if we de-select this item"
	     (isSelected = true and: [aValue not]) ifTrue: [
		    self announcer announce: ((OBSelectionChanged column: self) deselectedNode: (self children at: anIndex)).
	     ] ifFalse: [ "if we select an new item => check all old items"
	         (multipleSelection associationsDo: [:assoc | (assoc value = true and: [self paneExistsForSelection: assoc key]) ifFalse: [
			    multipleSelection at: assoc key put: false.
			]])
	     ]
     ].! !

!OBMultipleSelectionColumn methodsFor: 'testing' stamp: 'dr 8/21/2007 15:23'!
paneExistsForSelection: anIndex
    ^panel definitionPanel includesNode: (self children at: anIndex).! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 8/21/2007 15:23'!
preselectNodes
     self children keysAndValuesDo: [:idx :node | (panel definitionPanel includesNode: node) ifTrue: [multipleSelection at: idx put: true]]. ! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 7/4/2007 15:50'!
selection: anInteger
     "de-selected an item"
	anInteger = 0 ifTrue: [
         "primarySelection := oldPrimarySelection. self halt."
         "selection keysAndValuesDo: [:index :value | value ifTrue: [primarySelection := index]]."
	] ifFalse: [ 
	    oldSelection := selection.
	    selection _ anInteger.
	    (multipleSelection isEmpty and: [self = panel columns last]) ifTrue: [multipleSelection at: anInteger put: true].
         self signalSelectionChanged.
	]. 
	self changed: #selection.
! !

OBColumn subclass: #OBSmartGroupColumn
	instanceVariableNames: 'smartGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupColumn methodsFor: 'updating' stamp: 'dr 6/7/2007 16:30'!
childrenChanged: announcement
	(announcement node isKindOf: OBSmartGroupNode) ifTrue:
		[self refresh].! !

!OBSmartGroupColumn methodsFor: 'nodes' stamp: 'dr 7/4/2007 15:50'!
nextMetaNode
    ^panel root metaNode! !

!OBSmartGroupColumn methodsFor: 'accessing' stamp: 'dr 4/5/2007 14:48'!
parent
	^smartGroup! !

!OBSmartGroupColumn methodsFor: 'accessing' stamp: 'dr 8/21/2007 15:44'!
selectedNode
	^fan children at: self selection ifAbsent: [panel root].! !

!OBSmartGroupColumn methodsFor: 'nodes' stamp: 'dr 7/4/2007 15:50'!
selectionChanged: ann
    (ann node respondsTo: #alias) ifTrue: [panel jumpTo: ann node alias].! !

!OBSmartGroupColumn methodsFor: 'initializing' stamp: 'dr 7/19/2007 10:32'!
setPanel: aPanel metaNode: aMetaNode node: aNode
    smartGroup := aNode.
    super setPanel: aPanel metaNode: aMetaNode node: aNode.
    ! !

!OBSmartGroupColumn methodsFor: 'updating' stamp: 'dr 5/29/2007 10:58'!
subscribe
    super subscribe.
    self announcer observe: OBSelectionChanged send: #selectionChanged: to: self.! !

!MCWorkingCopy methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2007 10:14'!
asNode
    ^OBMonticelloPackageNode on: self! !

OBCmdRenameCat subclass: #OBCmdRenameSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
execute
	| category |
	category := OBTextRequest
				prompt: 'Please type new category name' 
				template: target name.
	category ifNotNil:	
		[target name: category.
		 requestor panel columns first refresh.]! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
group
	^ #general! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 15:53'!
isActive 
	^target isSmartGroupCategory! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 10:17'!
isMethodHolderNode
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/10/2007 11:22'!
isSmartGroup
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/16/2007 11:32'!
isSmartGroupCategory
    ^false! !

OBCodeNode subclass: #OBMonticelloPackageNode
	instanceVariableNames: 'mcPackage theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMonticelloPackageNode commentStamp: 'dr 7/16/2007 10:36' prior: 0!
I represent a Monticello package as a node in an OB system browser. My children are class, comment and metaclass nodes. Classes extended in the package I represent are also contained as nodes in my children.!

!OBMonticelloPackageNode class methodsFor: 'instance creation' stamp: 'dr 7/17/2007 10:18'!
on: aWorkingCopy
    ^self new mcPackage: aWorkingCopy! !

!OBMonticelloPackageNode class methodsFor: 'instance creation' stamp: 'dr 7/16/2007 11:15'!
package: aPackage class: aClass
	^self new mcPackage: aPackage; theClass: aClass! !

!OBMonticelloPackageNode methodsFor: 'comparing' stamp: 'dr 7/16/2007 10:33'!
= other 
	^ (other isKindOf: OBMonticelloPackageNode) 
		ifTrue: [self mcPackage = other mcPackage]
		ifFalse: [super = other]! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:41'!
askForRepository

	| reps index |
	reps := self repositories.
	index := (PopUpMenu labelArray: (reps collect: [:rep | rep description]))
				startUpWithCaption: 'Repository:'.
	^(index = 0) ifTrue: [nil] ifFalse: [reps at: index]! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 12/10/2007 10:21'!
browse
	OBPackageBrowser openOnPackage: self mcPackage! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 12/14/2007 11:59'!
checkForNewerVersionsAndAskIn: repository

	| newer |
	newer := mcPackage possiblyNewerVersionsIn: repository.
	^ newer isEmpty or: [
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, newer asString, String cr,
			'Do you really want to save this version?'].! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 12/14/2007 11:59'!
checkForNewerVersionsIn: repository
	| newer |
	newer := mcPackage possiblyNewerVersionsIn: repository.
	^ newer isEmpty not! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 11/27/2007 15:11'!
classCategories
    | pkgName pkgNameSize |
    pkgName := self mcPackage packageName, '-'.
    pkgNameSize := pkgName size.
    ^self class environment organization categories select: [:cat | 
	    cat size > pkgNameSize and: [(pkgName = (cat first: pkgNameSize))]].
! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 8/4/2006 20:33'!
classLevelProtocols

	^ theClass class organization categories
		collect: [:cat | (OBMethodCategoryNode on: cat inClass: theClass) browser: self browser]! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'ms 12/19/2007 00:38'!
classes
	"Note: differentiate between classes and extension classes so that I can wrap them differently so that I can control how they are shown, e.g. extension classes in italic."

	| classes extensions | 
	classes := mcPackage packageInfo classes collect: [:each | each asNode].
	extensions := mcPackage packageInfo extensionClasses collect: [:each | (OBClassExtensionNode on: each theNonMetaClass) extName: mcPackage packageName; yourself]. 
	^(classes asSet addAll: extensions; yourself) asArray! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'rw 7/2/2006 18:42'!
classesForPackage
	"return all classes for the selected package"

	^self classesHierarchically! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/20/2006 15:26'!
classesHierarchically

	^OBClassAwareNode sortHierarchicallyOptimized: self classes! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 5/2/2007 15:17'!
comments
	^self classes collect: [:each | each theClass asCommentNode]! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'rw 7/18/2006 17:58'!
commentsHierarchically
	^ OBClassAwareNode sortHierarchicallyOptimized: self comments! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 11/19/2007 10:40'!
definition
	^ OBClassDefinition 
		environment: self environment 
		template: ((self environment at: #Class) template: self name)! !

!OBMonticelloPackageNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:36'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 10:39'!
environment
    ^self class environment! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'dr 7/16/2007 10:33'!
findClass
	| pattern foundClassOrTrait package |
	pattern := UIManager default request: 'Class name or fragment?'.
	pattern isEmpty ifTrue: [^ self].
	foundClassOrTrait := Utilities classFromPattern: pattern withCaption: ''.
	foundClassOrTrait ifNil: [^ self].
	package := self packageForClassOrTrait: foundClassOrTrait
				ifAbsent: [^ self].
	(OBMonticelloPackageNode package: package class: foundClassOrTrait asNode) 
		signalSelection! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:05'!
hasRepository

	^self repositories notEmpty! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 5/4/2007 12:00'!
indentedName
	^mcPackage modified ifTrue: ['* ', self name] ifFalse: [' ', self name]! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 4/17/2007 15:40'!
instLevelProtocols

	^ theClass organization categories
		collect: [:cat | OBMethodCategoryNode on: cat inClass: theClass]! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 5/2/2007 15:34'!
isDescendantOf: other
	^other class = self class and: [other mcPackage = self mcPackage]! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 7/16/2007 11:32'!
isDescendantOfClassCat: other
    ^self = other! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 5/2/2007 14:58'!
isDescendantOfPackage: other
	^other class = self class and: [other mcPackage = self mcPackage]! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 7/16/2007 11:17'!
mcPackage
	^mcPackage! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'rw 6/4/2006 21:17'!
mcPackage: aWorkingCopy

	mcPackage := aWorkingCopy! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'ms 12/19/2007 00:38'!
metaclasses
	| metaclasses extensions | 
	metaclasses := mcPackage packageInfo classes collect: [:each | each asClassSideNode].
	extensions := mcPackage packageInfo extensionClasses collect: [:each | (OBMetaclassExtensionNode on: each theNonMetaClass) extName: mcPackage packageName; yourself]. 
	^(metaclasses asSet addAll: extensions; yourself) asArray! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'rw 7/18/2006 17:58'!
metaclassesHierarchically

	^ OBClassAwareNode sortHierarchicallyOptimized: self metaclasses! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 5/4/2007 12:00'!
name
	^mcPackage packageName! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/7/2006 14:35'!
packageForClassOrTrait: classOrTrait ifAbsent: absentblock

	MCWorkingCopy allManagers do: [:wc |
		(wc package packageInfo classes includes: classOrTrait)
			ifTrue: [^wc]
	].
	^absentblock value! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 7/16/2007 11:03'!
repositories
	^mcPackage repositoryGroup repositories! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 8/4/2006 23:06'!
showComment
	| defPanel columnPanel classColumn |

	defPanel := self browser panels last.
	columnPanel := self browser panels first.
	classColumn := columnPanel columnBefore: columnPanel currentColumn.
	classColumn ifNotNil: [
	    (defPanel isKindOf: OBDefinitionPanel) ifTrue: [defPanel definition: (OBClassCommentNode on: theClass)].
	].! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 10:33'!
text
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self name, ''''! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'rw 6/10/2006 14:03'!
theClass: aClassNode

	theClass := aClassNode theClass! !

OBCodeNode subclass: #OBPackagesOrClassesNode
	instanceVariableNames: 'mcPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackagesOrClassesNode commentStamp: 'dr 7/16/2007 10:34' prior: 0!
I represent the root of the node tree in an OB system browser. My children are Monticello packages and Monticello class categories.!

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/16/2007 15:35'!
environment
    ^Smalltalk! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:25'!
indentedName 
	^self name! !

!OBPackagesOrClassesNode methodsFor: 'testing' stamp: 'dr 7/16/2007 15:33'!
isEnvironment
	^ true! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'rw 6/9/2006 01:07'!
mcPackage: aWorkingCopy

	mcPackage := aWorkingCopy! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'dr 7/16/2007 11:13'!
mcRepository
	^MCCacheRepository default! !

!OBPackagesOrClassesNode methodsFor: 'public' stamp: 'dr 7/16/2007 11:13'!
name
	^self mcRepository description! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/16/2007 10:42'!
packages
	| workingCopies packages remainingCats coveredCats |
	coveredCats := Set new.
	workingCopies := MCWorkingCopy allManagers 
				asSortedCollection: [:a :b | a package name <= b package name].
	packages := OrderedCollection new.
	workingCopies do: 
			[:wc | 
			| packageNode |
			coveredCats add: wc packageName.
			packageNode := OBMonticelloPackageNode new mcPackage: wc.
			packages add: packageNode.
			packageNode classCategories do: 
					[:classCategory | 
					coveredCats add: classCategory.
					packages add: (OBMonticelloClassCategoryNode on: classCategory)]].
	remainingCats := SystemOrganization categories asSet 
				difference: coveredCats.
	remainingCats ifNotEmpty: 
			[packages add: (OBMonticelloPackageNode new 
						mcPackage: (OBDummyPackage categories: remainingCats)).
			remainingCats asSortedCollection 
				do: [:classCategory | packages add: (OBMonticelloClassCategoryNode on: classCategory)]].
	^ packages! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/16/2007 11:13'!
text
	^'Euh - something regarding an MCCachedRepository ?!!'! !

OBCodeNode subclass: #OBSmartAliasNode
	instanceVariableNames: 'node parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartAliasNode class methodsFor: 'as yet unclassified' stamp: 'dr 3/13/2007 18:10'!
node: aNode
    ^self new node: aNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:09'!
alias
	^self node! !

!OBSmartAliasNode methodsFor: 'actions' stamp: 'dr 4/10/2007 10:53'!
browse
    self node browse! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/3/2007 11:18'!
categories
	^ Smalltalk organization categories collect: [:cat | OBClassCategoryNode 
															on: cat
															inEnvironment: Smalltalk]! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 4/10/2007 11:11'!
indent
	| indent |
	indent := Text new: 4.
	indent atAllPut: $ .
	^ indent! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 4/10/2007 11:11'!
indentedName
	^ self indent, self name! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:30'!
isDescendantOf: aNode
    ^false! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:32'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:11'!
name
    ^self node name! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node
	^node! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node: aNode
	node := aNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:38'!
packages
    ^self parentNode parentNode panel root packages! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode
	^parentNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartAliasNode methodsFor: 'printing' stamp: 'dr 4/5/2007 14:37'!
printOn: aStream
    super printOn: aStream.
    aStream nextPutAll: ' ('.
    self node printOn: aStream. 
    aStream nextPut: $).! !

!OBSmartAliasNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:00'!
remove
    ^self parentNode nodes remove: self.! !

OBCodeNode subclass: #OBSmartGroupNode
	instanceVariableNames: 'name nodes parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/5/2007 17:04'!
name: aString
    ^self new name: aString! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 10:47'!
addAlias: aNode
    ^self addNode: (OBSmartAliasNode node: aNode).! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 15:58'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartGroupNode methodsFor: 'drag and drop' stamp: 'dr 6/7/2007 16:19'!
dropSelector
    ^#dropOnSmartGroup:! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/10/2007 10:58'!
indentedName
    ^self name! !

!OBSmartGroupNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:33'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/16/2007 11:32'!
isSmartGroupCategory
    ^true! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 6/7/2007 16:31'!
name.
	^name! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/5/2007 16:34'!
name: anObject
	name := anObject! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 10:48'!
nodes
    nodes ifNil: [nodes := OrderedCollection new].
    ^nodes! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:58'!
parentNode
	^parentNode! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:01'!
remove
    ^self parentNode nodes remove: self.! !

OBCodeNode subclass: #OBSmartRootNode
	instanceVariableNames: 'nodes panel'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartRootNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/16/2007 16:29'!
default 
    Instances ifEmpty: [Instances add: self new].
    ^Instances last! !

!OBSmartRootNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/16/2007 16:30'!
initialize
    "self initialize"
    Instances ifNil: [Instances := OrderedCollection new].! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/12/2007 17:12'!
addAlias: aNode
    ^self addNode: (OBSmartAliasNode node: aNode).! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:23'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:02'!
allNodes
    ^self nodes inject: OrderedCollection new into: [:coll :ea | coll add: ea. coll addAll: ea nodes. coll].
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:05'!
isDescendantOf: aNode
    ^false! !

!OBSmartRootNode methodsFor: 'navigating' stamp: 'dr 7/19/2007 15:37'!
name
    ^'smart root node'! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:38'!
nodes
    | rootNode | 
    nodes ifNil: [
        rootNode := OBSmartGroupNode name: 'default'.
        rootNode addAlias: (OBClassNode on: Behavior).
        rootNode addAlias: (OBClassNode on: OBColumn).
        rootNode addAlias: (OBClassNode on: String).
        rootNode addAlias: (OBMethodNode on: #subclasses inClass: Class).  
	 
        nodes := OrderedCollection new.
        self addNode: rootNode.
    ].
    ^nodes
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:39'!
panel
	^panel! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:39'!
panel: aPanel
	panel := aPanel! !

OBSystemBrowserAdaptor subclass: #OBMultipleSelectionBrowserAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'configuration' stamp: 'dr 7/19/2007 16:36'!
browserClass
    ^OBMultipleSelectionBrowser! !

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:37'!
initialize
     "self initialize"
	self register! !

OBSystemBrowserAdaptor subclass: #OBPackageBrowserAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackageBrowserAdaptor class methodsFor: 'configuration' stamp: 'dr 12/14/2007 09:56'!
browserClass
"self register"
    ^OBPackageBrowser! !

!OBPackageBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 12/14/2007 11:39'!
initialize
	self register! !

!OBPackageBrowserAdaptor methodsFor: 'registry protocol' stamp: 'dr 12/14/2007 09:56'!
labelString
    ^'Package Browser'! !

!OBBrowser methodsFor: '*ob-enhancements' stamp: 'dr 5/24/2007 12:21'!
definitionPanel
	^ panels 
		detect: [:ea | ea isDefinition] 
		ifNone: [self error: 'No definition panel configured']! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 7/23/2007 14:23'!
closableDefinitionPanel: aDefinitionPanel with: aBlock
	| morph contentMorph | 
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
     
     ((aDefinitionPanel respondsTo: #codeTabPanel) and: [aDefinitionPanel codeTabPanel commands notEmpty]) ifTrue: [
	    morph addMorphBack: (aDefinitionPanel codeTabPanel buildOn: self).	
	].	
	aDefinitionPanel hasSeveralPanels ifTrue: [morph addMorphBack: aDefinitionPanel createTitleBar].	
	contentMorph := aDefinitionPanel createContentMorph.
	aDefinitionPanel setContentMorph: contentMorph.
	morph addMorphBack: contentMorph.
	
	current ifNotNil: [current addMorphBack: morph].
	^ self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements-diagrams' stamp: 'dr 7/18/2007 15:16'!
codeTabPanel: aCodeTabPanel with: aBlock
	| tabPanel |
	tabPanel _ OBRadioButtonBar
					on: aCodeTabPanel
					list: #list
					selected: #selection
					changeSelected: #selection:.
	tabPanel height: 23;
		      hResizing: #shrinkWrap;
		      vResizing: #shrinkWrap;
		      cellInset: aCodeTabPanel cellInset;	
	           cellPositioning: #topLeft.	
	tabPanel adoptPaneColor: aCodeTabPanel browser defaultBackgroundColor darker darker darker.	
		
	current ifNotNil: [current addMorphBack: tabPanel].
	^ self current: tabPanel do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:28'!
createPaneForColumn: aColumn with: listSelector
	| pane |
	pane _ OBPane new.
	pane 
		model: aColumn;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self perform: listSelector with: aColumn).
		
	^pane	! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:29'!
multipleDefinitionPanel: aMultipleDefinitionPanel with: aBlock
	| morph |
	morph _ (OBPaneScroller withModel: aMultipleDefinitionPanel)
		name: 'def';
		yourself.		
	current ifNotNil: [current addMorphBack: morph].
	^ self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:27'!
multipleSelectionColumn: aColumn with: aBlock
   	| pane |
     pane := self createPaneForColumn: aColumn with: #multipleSelectionListMorphForColumn:.
	current ifNotNil: [current pushPane: pane].
	^ self current: pane do: aBlock
! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:23'!
multipleSelectionListMorphForColumn: aColumn
	^ (OBPluggableListMorphOfMany
		on: aColumn
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu:
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: aColumn dragEnabled;
			dropEnabled: aColumn dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			yourself! !

MethodReference subclass: #MethodExtensionReference
	instanceVariableNames: 'extensionName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!MethodExtensionReference methodsFor: 'accessing' stamp: 'ms 12/19/2007 13:28'!
asNode

	^(extensionName asLowercase beginsWith: (self category asString asLowercase  copyFrom: 2 to: self category size))
			ifTrue: [OBMethodExtensionNode on: self]
			ifFalse: [OBMethodNode on: self]! !

!MethodExtensionReference methodsFor: 'accessing' stamp: 'ms 12/19/2007 01:14'!
extensionName
	^ extensionName! !

!MethodExtensionReference methodsFor: 'accessing' stamp: 'ms 12/19/2007 01:14'!
extensionName: anObject
	extensionName := anObject! !

OBPanel subclass: #OBMultipleDefinitionPanel
	instanceVariableNames: 'panels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/21/2007 16:44'!
aboutToChange: ann
   " self panels first aboutToChange: ann."! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 11:13'!
addPanel: aPanel
    "remove empty standard panel"
    (panels size = 1 and: [panels first node isNil]) ifTrue: [panels := OrderedCollection new].

    aPanel owner: self.
    panels add: aPanel.

    "make sure that the first panel also get buttons as soon as a second panel is added"
    panels size = 2 ifTrue: [panels first createMorph].

    self browser ifNotNil: [aPanel browser: self browser].
    self changed: #columns! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/8/2007 11:40'!
browser: aBrowser
    super browser: aBrowser.
    self panels do: [:ea | ea browser: aBrowser].! !

!OBMultipleDefinitionPanel methodsFor: 'building' stamp: 'dr 6/12/2007 16:11'!
buildOn: aBuilder
	^ aBuilder multipleDefinitionPanel: self with: []! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/12/2007 16:12'!
columns
   ^self panels! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:29'!
defaultBackgroundColor
	^ browser defaultBackgroundColor! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/29/2007 15:55'!
definitionChanged: ann
    "self panels first definition: ann definition.
    self panels first definitionChanged: ann."! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
hasChangeablePanel
    ^self panels anySatisfy: [:ea | ea isChangeable].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/25/2007 17:29'!
hasMethodPanel
    ^self panels anySatisfy: [:ea | ea node isKindOf: OBMethodNode].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/29/2007 10:40'!
includesNode: aNode
    ^self panels anySatisfy: [:ea | ea node = aNode].! !

!OBMultipleDefinitionPanel methodsFor: 'initializing' stamp: 'dr 6/7/2007 11:55'!
initialize
    panels := OrderedCollection new.    
    self addPanel: OBClosableDefinitionPanel new.
    ! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel after: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel after: secondPanel.
    self panels removeAt: removeIdx.
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel before: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel before: secondPanel.
    self panels removeAt: (removeIdx + 1).
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:45'!
is: firstClosableDefinitionPanel placedBefore: secondClosableDefinitionPanel
    ^(self panels indexOf: firstClosableDefinitionPanel) < (self panels indexOf: secondClosableDefinitionPanel)! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/24/2007 12:20'!
isDefinition
   ^true! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/7/2007 11:50'!
lastChangeablePanel "self halt."
    ^self panels reversed detect: [:ea | ea isChangeable] ifNone: [nil].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/31/2007 17:12'!
lastIsNonMetaPanel
    ^(self lastPanel node isKindOf: OBMethodNode) not and: [self lastPanel isKindOf: OBClosableDefinitionPanel]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/31/2007 17:06'!
lastPanel
    ^self panels last! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:27'!
morph
	^ (OBPaneScroller withModel: self)
		name: 'def';
		yourself! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:32'!
morphHeight
	^ 0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 15:28'!
nodeDeleted: ann
    | deletedNodePanel  |
    (ann node isKindOf: OBMethodNode) ifTrue: [
	   deletedNodePanel := self panels detect: [:ea | ea node = ann node] ifNone: [nil].
	   deletedNodePanel ifNotNil: [self removePanel: deletedNodePanel column: nil]
    ].! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/24/2007 12:27'!
panels
   ^panels! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:26'!
panes
    ^panels collect: [:ea | ea morph]! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:44'!
reclaimPanes
    ^0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/18/2007 11:40'!
refresh: ann
    self panels first refresh: ann.! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 18:00'!
removeNonMethodPanels
	self panels copy do: [:ea | (ea node isKindOf: OBMethodNode) ifFalse: [self removePanel: ea]]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/25/2007 17:55'!
removePanel: aPanel
    ^self removePanel: aPanel column: nil! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/14/2007 10:39'!
removePanel: aPanel column: aColumn
    | newPanel theClass |
    panels remove: aPanel.
 
    "make sure that the last panels does not have any buttons"
    panels size = 1 ifTrue: [panels first createMorph].
    
    "make sure that there is always at least a standard panel"
    panels ifEmpty: [ 
	    newPanel := OBClosableDefinitionPanel new. 
	    aColumn ifNotNil: [newPanel definition: aColumn selectedNode definition]
	               ifNil: [aPanel node ifNotNil: [theClass := aPanel node theClass.
			            newPanel definition: (OBMethodDefinition source: theClass sourceCodeTemplate inClass: theClass)]]. 
	    self addPanel: newPanel.
    ].
    self changed: #columns! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 8/24/2007 13:30'!
selectionChanged: ann
    | newPanel newDefinition deselectedPanel panel |
    self flag: #toRefactor.

	ann deselectedNode ifNotNil: [
       deselectedPanel := self panels detect: [:ea | ea node = ann deselectedNode] ifNone: [nil].
       deselectedPanel ifNotNil: [self removePanel: deselectedPanel column: ann column]
	] ifNil: [.
        (self panels noneSatisfy: [:ea | ea node = ann node]) ifTrue: [
	       newDefinition := ann node ifNotNil: [ann node definition].
		  (newDefinition notNil and: [newDefinition text notEmpty]) ifTrue: [
	           (self hasChangeablePanel and: [ActiveEvent isNil or: [ActiveEvent shiftPressed not]]) ifTrue: [
		             self lastChangeablePanel definition: newDefinition.
		             self lastChangeablePanel node: ann node.
		             self lastChangeablePanel changed. 
		             self changed: #columns. 		
		       ] ifFalse: [
                      newPanel := OBClosableDefinitionPanel new.
                      newPanel definition: newDefinition.
                      newPanel node: ann node.
                      self addPanel: newPanel.
                ].
             ] 
         ] ifFalse: [
                "update panel for this node with new source code"
                ann node ifNotNil: [
                    panel := self panels detect: [:ea | ea node = ann node].
                    panel definition: ann node definition.
                ]
         ].
     ].! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/29/2007 15:28'!
sizing 
    self panels ifEmpty: [^1].
    ^self panels size! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 14:57'!
subscribe
	self announcer 
		observe: OBAboutToChange
		send: #aboutToChange:
		to: self;
		
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self;
		
		observe: OBRefreshRequired
		send: #refresh:
		to: self;
				
		observe: OBDefinitionChanged
		send: #definitionChanged: 
		to: self;
		
		observe: OBNodeDeleted
		send: #nodeDeleted: 
		to: self.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
swap: firstPanel with: secondPanel
    self panels swap: (self panels indexOf: firstPanel) with: (self panels indexOf: secondPanel).
    self changed: #columns.
"self halt."! !

!OBPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/24/2007 12:20'!
isDefinition
   ^false! !

Object subclass: #OBDummyPackage
	instanceVariableNames: 'categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBDummyPackage commentStamp: 'dr 7/16/2007 10:42' prior: 0!
I am a dummy for a Monticello package. I am used for class categories existing in the image that are not contained in any Monticello package. I list all these ownerless class categories in alphabetical order. !

!OBDummyPackage class methodsFor: 'instance creation' stamp: 'dr 7/22/2007 12:00'!
categories: aCollection
    ^self new categories: aCollection! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 6/18/2007 17:10'!
categories
    ^categories! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 6/18/2007 17:09'!
categories: aCollection
    categories := aCollection! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:09'!
classes
    ^(self categories gather: 
		[:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]])
				sortBy: [:a :b | a className <= b className]! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:10'!
extensionClasses
    ^OrderedCollection new! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 16:57'!
modified
    ^false! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:08'!
packageInfo
    ^self! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:02'!
packageName
    ^'Unpackaged'! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 16:57'!
repositories
    ^OrderedCollection new! !

OBClassNode subclass: #OBClassExtensionNode
	instanceVariableNames: 'extName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBClassExtensionNode methodsFor: 'navigating' stamp: 'ms 12/19/2007 01:18'!
allCategory
	^ Array with: ((OBAllMethodExtensionCategoryNode on: self theClass) extensionName: extName; yourself)! !

!OBClassExtensionNode methodsFor: 'navigating' stamp: 'ms 12/19/2007 13:27'!
categories
	^ self theClass organization categories
		collect: [:cat | (extName asLowercase beginsWith: (cat asString asLowercase  copyFrom: 2 to: cat size))
			ifTrue: [ OBMethodCategoryExtensionNode on: cat inClass: self theClass]
			ifFalse: [OBMethodCategoryNode on: cat inClass: self theClass]]! !

!OBClassExtensionNode methodsFor: 'displaying' stamp: 'dr 7/12/2007 17:16'!
emphasizedName	
	^Text string: super emphasizedName asString emphasis: {TextEmphasis italic} ! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'ms 12/19/2007 00:20'!
extName
	^ extName! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'ms 12/19/2007 00:20'!
extName: anObject
	extName := anObject! !

!OBClassExtensionNode methodsFor: 'testing' stamp: 'dr 5/2/2007 15:13'!
isDescendantOfClass: other
     ^false! !

!OBClassExtensionNode methodsFor: 'displaying' stamp: 'dr 7/16/2007 15:30'!
name
	^Text string: super name asString emphasis: {TextEmphasis italic} ! !

OBClassExtensionNode subclass: #OBMetaclassExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMetaclassExtensionNode methodsFor: 'actions' stamp: 'ms 12/19/2007 00:27'!
browse
	^ OBSystemBrowser openOnClass: self theNonMetaClass ! !

!OBMetaclassExtensionNode methodsFor: 'displaying' stamp: 'ms 12/19/2007 00:27'!
name 
	^ self nonMetaName! !

!OBMetaclassExtensionNode methodsFor: 'as yet unclassified' stamp: 'ms 12/19/2007 00:28'!
nonMetaName
	^ self theNonMetaClass name! !

!OBMetaclassExtensionNode methodsFor: 'initializing' stamp: 'ms 12/19/2007 00:28'!
setClass: aClass
	self theClass: aClass theMetaClass! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:34'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 7/18/2007 16:14'!
useMultipleSelection
    ^false! !

OBMethodNode subclass: #OBMethodExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMethodExtensionNode methodsFor: 'displaying' stamp: 'ms 12/19/2007 00:55'!
displayString
	
	^super displayString asText addAttribute: TextEmphasis bold! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:16'!
dropOnSmartGroup: aNode

	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:06'!
isMethodHolderNode
    ^true! !

OBSystemBrowser subclass: #OBPackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

OBPackageBrowser subclass: #OBMultipleSelectionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:09'!
definitionPanel
	^ OBMultipleDefinitionPanel new! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:10'!
initialize
	self registerInOpenMenu! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:17'!
methodColumnIndex
    ^4! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 17:52'!
navigationPanel
	^OBMultipleSelectionColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:08'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Image Browser'. {self. #open}}.! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:15'!
useMultipleSelection
    ^true! !

OBMultipleSelectionBrowser subclass: #OBSmartGroupBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 10:28'!
defaultMetaNode
    | env smartGroupMetaNode |
    env := super defaultMetaNode.
    smartGroupMetaNode := OBMetaNode named: 'SmartGroup'.
    smartGroupMetaNode
		displaySelector: #indentedName;
		childAt: #allNodes put: env.
    env displaySelector: #indentedName. 

    ^smartGroupMetaNode       ! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 4/17/2007 16:25'!
imageClass: classSel comment: commentSel metaclass: metaclassSel 
    | env smartGroupMetaNode |
    env := super imageClass: classSel comment: commentSel metaclass: metaclassSel.
    smartGroupMetaNode := OBMetaNode named: 'SmartGroup'.
    smartGroupMetaNode
		displaySelector: #indentedName;
		childAt: #allNodes put: env.
    env displaySelector: #indentedName. 

    ^smartGroupMetaNode       ! !

!OBSmartGroupBrowser class methodsFor: 'initializing' stamp: 'dr 5/8/2007 15:41'!
initialize
	self registerInOpenMenu! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:17'!
methodColumnIndex
    ^5! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 10:47'!
navigationPanel
	^OBSmartGroupColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 4/24/2007 15:38'!
paneCount
    ^5! !

!OBSmartGroupBrowser class methodsFor: 'initializing' stamp: 'dr 5/8/2007 15:40'!
registerInOpenMenu
     "self registerInOpenMenu"
	TheWorldMenu registerOpenCommand: {'SmartGroup Browser'. {self. #open}}.! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddSmartCategory
	^OBCmdAddSmartCategory! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddToSmartGroup
	^OBCmdAddToSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRemoveFromSmartGroup
	^OBCmdRemoveFromSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRenameSmartCategory
	^OBCmdRenameSmartCategory! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 7/20/2007 15:25'!
defaultMetaNode
	| env package |
	env := OBMetaNode named: 'Environment'.
	package := OBMetaNode named: 'Package'.
	env childAt: #packages put: package.
	package displaySelector: #indentedName.
	package ancestrySelector: #isDescendantOfClassCat:.
	self buildMetagraphOn: package.
	^env! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 7/20/2007 15:03'!
defaultRootNode
	^ OBPackagesOrClassesNode new! !

!OBPackageBrowser class methodsFor: 'instance creation' stamp: 'dr 7/20/2007 15:06'!
onMonticelloClassCategory: aString
	^self selection: (OBMonticelloClassCategoryNode on: aString)! !

!OBPackageBrowser class methodsFor: 'instance creation' stamp: 'dr 12/10/2007 10:22'!
onPackage: aPackage
	^self selection: aPackage asNode! !

!OBPackageBrowser class methodsFor: 'opening' stamp: 'dr 7/20/2007 15:07'!
openOnMonticelloClassCategory: aString
	^ (self onMonticelloClassCategory: aString) open! !

!OBPackageBrowser class methodsFor: 'opening' stamp: 'dr 7/20/2007 15:07'!
openOnPackage: aPackage
	^ (self onPackage: aPackage) open! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:33'!
cmdAddWorkingCopy
    ^OBCmdAddWorkingCopy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:33'!
cmdBrowseWorkingCopy
	^OBCmdBrowseWorkingCopy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdPublishPackage
	^OBCmdPublishPackage! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:38'!
cmdRemoveWorkingCopy
	^OBCmdRemoveWorkingCopy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 12/14/2007 15:16'!
cmdUpdatePackage
	^OBCmdUpdatePackage ! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdViewChanges
	^OBCmdViewChanges! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdViewHistory
	^OBCmdViewHistory! !

OBAllMethodCategoryNode subclass: #OBAllMethodExtensionCategoryNode
	instanceVariableNames: 'extensionName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'ms 12/19/2007 01:17'!
extensionName
	^ extensionName! !

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'ms 12/19/2007 01:17'!
extensionName: anObject
	extensionName := anObject! !

!OBAllMethodExtensionCategoryNode methodsFor: 'as yet unclassified' stamp: 'ms 12/19/2007 01:21'!
methodReferences
	^ self theClass selectors asSortedArray 
		collect: [:ea | MethodExtensionReference new setStandardClass: self theClass methodSymbol: ea; extensionName: extensionName]! !

OBClassCategoryNode subclass: #OBMonticelloClassCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMonticelloClassCategoryNode commentStamp: 'dr 7/16/2007 10:37' prior: 0!
I represent a class category contained in a Monticello package.!

!OBMonticelloClassCategoryNode methodsFor: 'actions' stamp: 'dr 12/10/2007 10:21'!
browse
	OBPackageBrowser openOnMonticelloClassCategory: name! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 8/1/2006 19:10'!
classesForPackage
	^self classesHierarchically! !

!OBMonticelloClassCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:35'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 7/16/2007 14:24'!
indentedName
    | indent |
    indent := '    '.
    ^indent, self name! !

!OBMonticelloClassCategoryNode methodsFor: 'testing' stamp: 'dr 7/16/2007 10:33'!
isDescendantOf: packageNode 
	^ (packageNode isKindOf: OBMonticelloPackageNode) 
		and: [packageNode classCategories includes: self name]! !

!OBMonticelloClassCategoryNode methodsFor: 'testing' stamp: 'dr 5/2/2007 15:13'!
isDescendantOfClass: other
     ^false! !

PluggableListMorphOfMany subclass: #OBPluggableListMorphOfMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 8/21/2007 15:20'!
iconAt: index
	^ model iconAt: index! !

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 6/7/2007 15:53'!
listMorphClass
    ^OBLazyListMorph! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 10:51'!
mouseDown: evt
	| selectors row oldIndex oldVal |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	row _ self rowAtLocation: evt position.
	row = 0  ifTrue: [^super mouseDown: evt].
	"self dragEnabled ifTrue: [aMorph highlightForMouseDown]."
	
	model okToChange ifFalse: [^ self].  "No change if model is locked"

	"Set meaning for subsequent dragging of selection"
	dragOnOrOff _ (self listSelectionAt: row) not.
	oldIndex _ self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal _ self listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.	
	
	selectors _ Array 
		with: nil"#click:"
		with: (doubleClickSelector ifNotNil:[#doubleClick:])
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10 ! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 10:44'!
mouseMove: evt

	| oldIndex oldVal row |
	(self dropEnabled and: [evt hand hasSubmorphs]) 
		ifFalse:[^super mouseMove: evt].
	potentialDropRow ifNotNil:[
		potentialDropRow = (self rowAtLocation: evt position)
			ifTrue:[^self].
	].
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) 
		ifTrue:[self mouseEnterDragging: evt].
		
	"Set meaning for subsequent dragging of selection"
	oldIndex := self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].

     row _ self rowAtLocation: evt position.
	"Set or clear new primary selection (listIndex)"
	dragOnOrOff 
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.
	row changed	! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 11:18'!
mouseUp: event 
	"The mouse came up within the list; take appropriate action"
	| row |
	row := self rowAtLocation: event position.
	"aMorph ifNotNil: [aMorph highlightForMouseDown: false]."
	model okToChange
		ifFalse: [^ self].
	"No change if model is locked"
	
	dragOnOrOff _ nil.  "So improperly started drags will have not effect"	
	
	"row == self selectionIndex
		ifTrue: [(autoDeselect ifNil: [true]) ifTrue:[row == 0 ifFalse: [self changeModelSelection: 0] ]]
		ifFalse: [self changeModelSelection: row]."
	Cursor normal show! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 2/7/2008 11:14'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection result |
	oldSelection _ self getCurrentSelectionIndex.
	result := super specialKeyPressed: asciiValue.	
	self listSelectionAt: oldSelection put: false.
	^result! !

!MCFileBasedRepository methodsFor: '*ob-enhancements' stamp: 'dr 12/14/2007 14:35'!
versionsAvailableForPackage: aPackage
    ^self allVersionNames select: [:versionName | versionName beginsWith: aPackage packageName]! !

!OBColumnPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 10:36'!
definitionPanel
    ^browser definitionPanel! !

OBColumnPanel subclass: #OBMultipleSelectionColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMultipleSelectionColumnPanel methodsFor: 'accessing columns' stamp: 'dr 7/20/2007 13:53'!
emptyColumn
     | columnClass methodColumnIdx |
     columnClass := OBEnhancementColumn.

     browser class useMultipleSelection ifTrue: [
	    methodColumnIdx := browser class methodColumnIndex.    
         self columns size = (methodColumnIdx - 1) ifTrue: [columnClass := OBMultipleSelectionColumn].
     ].
	^columnClass inPanel: self! !

OBMultipleSelectionColumnPanel subclass: #OBSmartGroupColumnPanel
	instanceVariableNames: 'smartGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

!OBSmartGroupColumnPanel methodsFor: 'navigating' stamp: 'dr 8/22/2007 16:18'!
selecSubtree: aSubtree
	| myColumns |
	myColumns_ smartGroup ifNil: [columns] ifNotNil: [columns allButFirst].self halt.
	aSubtree selectInColumns: myColumns! !

!OBSmartGroupColumnPanel methodsFor: 'navigating' stamp: 'dr 7/19/2007 10:37'!
selectPath: aCollection
	| column parent |
	column_ smartGroup ifNil: [columns first] ifNotNil: [columns second].
	parent _ self root.
	aCollection do:
		[:node |
		column parent: parent child: node.
		column _ column next.
		parent _ node].! !

!OBSmartGroupColumnPanel methodsFor: 'navigating' stamp: 'dr 8/22/2007 16:19'!
selectSubtree: aSubtree
	| myColumns |
	myColumns_ smartGroup ifNil: [columns] ifNotNil: [columns allButFirst].
	aSubtree selectInColumns: myColumns! !

!OBSmartGroupColumnPanel methodsFor: 'updating' stamp: 'dr 7/19/2007 10:38'!
selectionChanged: ann
     (ann column isKindOf: OBSmartGroupColumn) ifTrue: [^self].
     super selectionChanged: ann.! !

!OBSmartGroupColumnPanel methodsFor: 'initializing' stamp: 'dr 8/22/2007 16:20'!
setMetaNode: aMetaNode node: aNode 
	| metaNode |
	metaNode := aMetaNode.
	metaNode name = 'SmartGroup' ifTrue: [
	    metaNode := (aMetaNode children detect: [:ea | ea name = 'Environment']).	
	    smartGroup := OBSmartRootNode default.
	    smartGroup panel: self.
	    self pushColumn: (OBSmartGroupColumn 
				inPanel: self
				metaNode: aMetaNode
				node: smartGroup).		
	].
	super setMetaNode: metaNode node: aNode.! !

!OBSmartGroupColumnPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 11:01'!
smartGroup
    ^smartGroup! !

OBMethodCategoryNode subclass: #OBMethodCategoryExtensionNode
	instanceVariableNames: 'extName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMethodCategoryExtensionNode methodsFor: 'displaying' stamp: 'ms 12/19/2007 00:14'!
displayString
	^super displayString asText addAttribute: TextEmphasis bold! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:34'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:07'!
isMethodHolderNode
    ^true! !

OBCommand subclass: #OBCmdAddSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 15:52'!
execute
	| name |
	name := OBTextRequest 
					prompt: 'Please type new category name' 
					template: ''.
	name ifNil: [^self].

    requestor panel smartGroup addNode: (OBSmartGroupNode name: name).
    requestor panel columns first refresh.! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:18'!
group
	^ #general! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:25'!
isActive 
	^ target isSmartGroup! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:18'!
label
    ^'new category...'! !

OBCommand subclass: #OBCmdAddToSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 7/19/2007 13:55'!
execute
    | selection smartGroups |

    smartGroups := requestor panel smartGroup nodes select: [:ea | ea isSmartGroupCategory].

    selection := OBChoiceRequest prompt: nil labels: (smartGroups collect: [:ea | ea name]) values: smartGroups.
    selection ifNotNil: [selection addAlias: target].

    requestor panel columns first refresh.
    self select: target with: requestor announcer! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
group
	^ #navigation! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 5/29/2007 17:22'!
isActive
	^(requestor browser isKindOf: OBSmartGroupBrowser) and: [target isSmartGroup not
		and: [requestor isSelected: target]]! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
label
    ^'add to smart group'! !

OBCommand subclass: #OBCmdAddWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/17/2007 10:17'!
execute
	| name package workingCopy |
	name := FillInTheBlankMorph request: 'Name of package:'. 
	name isEmptyOrNil ifTrue: [^self].
	PackageInfo named: name. 
	package := (MCPackage new name: name).
	workingCopy := MCWorkingCopy forPackage: package.
	self select: (OBMonticelloPackageNode on: workingCopy) with: requestor announcer! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 5/3/2007 16:15'!
group
	^ #general! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 11/17/2007 13:11'!
isActive
	^ target isEnvironment! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 5/3/2007 16:15'!
label
    ^'add package'! !

OBCommand subclass: #OBCmdBrowseWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:33'!
execute
	(MCSnapshotBrowser forSnapshot: target mcPackage package snapshot)
			label: 'Snapshot Browser: ', target mcPackage packageName;
			show! !

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:34'!
group
    ^#general! !

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:34'!
label
    ^'browse package'! !

OBCommand subclass: #OBCmdPublishPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 11:55'!
execute
	| repository |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^self].
	(target checkForNewerVersionsAndAskIn: repository) ifFalse: [^self].
	
	target mcPackage newVersion ifNotNilDo:
		[:v |
		(MCVersionInspector new version: v) show.
		Cursor wait showWhile: [repository storeVersion: v].
		v allAvailableDependenciesDo:
			[:dep |
			(repository includesVersionNamed: dep info name)
				ifFalse: [repository storeVersion: dep]]].
	requestor announce: (OBChildrenChanged node: requestor parent).	! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:11'!
group
    ^#general! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:10'!
label
    ^'publish'! !

OBCommand subclass: #OBCmdRemoveFromSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 7/19/2007 13:57'!
execute
    target remove.
    requestor panel columns first refresh.
    self select: target with: requestor announcer! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
group
	^ #navigation! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/16/2007 15:55'!
isActive
	^target isSmartGroup
		and: [requestor isSelected: target]! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
label
    ^'remove'! !

OBCommand subclass: #OBCmdRemoveWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 15:23'!
execute
	(PopUpMenu confirm: 'Really remove package?')
		ifTrue: [target mcPackage unregister. requestor announce: (OBNodeDeleted node: target)]! !

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:48'!
group
	^ #general! !

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:49'!
label
    ^'remove package'! !

OBCommand subclass: #OBCmdUpdatePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 15:00'!
execute
	| repository versions fileName |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^self]. 
	(target checkForNewerVersionsIn: repository) ifFalse: [self inform: 'There are no newer versions available in this repository.'. ^self].
	
	versions := (repository versionsAvailableForPackage: target mcPackage) select: [:version | version last isDigit].
	versions := versions asSortedCollection: [:a :b | | versionNr1 versionNr2 | 
	    	versionNr1 := (a copyAfterLast: $.) asInteger.
		versionNr2 := (b copyAfterLast: $.) asInteger.
		versionNr1 >= versionNr2
	].

     (self confirm: 'Do you want to load version ', versions first , '?') ifTrue: [
	    fileName := (repository allFileNamesForVersionNamed: versions first) first.
	    Cursor wait showWhile: [(repository versionFromFileNamed: fileName) load]
	].
	
	requestor announce: (OBChildrenChanged node: requestor parent).	! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
group
    ^#general! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
label
    ^'update'! !

OBCommand subclass: #OBCmdViewChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dc 1/7/2008 14:18'!
execute
	| patch repository |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^ self].
	patch := target mcPackage changesRelativeToRepository: repository.
	patch isNil ifTrue: [^ self].
	patch isEmpty
		ifTrue: [target mcPackage modified: false.
				self inform: 'No changes' ]
		ifFalse:
				[target mcPackage modified: true.
				(MCPatchBrowser forPatch: patch)
					label: 'Patch Browser: ', target mcPackage description;
					show]! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:36'!
group
    ^#general! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:36'!
label
    ^'changes'! !

OBCommand subclass: #OBCmdViewHistory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
execute
	target mcPackage ifNil: [^self].
	(MCWorkingHistoryBrowser new
				ancestry: target mcPackage ancestry;
				package: target mcPackage package)
			label:  'Version History: ', target mcPackage packageName;
			show! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
group
    ^#general! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
label
    ^'history'! !

!OBCommand methodsFor: '*ob-enhancements' stamp: 'dr 6/28/2007 16:24'!
wantsTabButton
    ^false! !

PluggableButtonMorph subclass: #OBDraggableButtonMorph
	instanceVariableNames: 'dropOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBDraggableButtonMorph commentStamp: 'dr 6/12/2007 15:21' prior: 0!
I represent a button morph which is draggable. Other draggable button morphs can be dropped on me.!

!OBDraggableButtonMorph methodsFor: 'events-processing' stamp: 'dr 6/11/2007 15:44'!
acceptDroppingMorph: aMorph event: evt 
     model dropMorph: aMorph.
	
	self resetDropOn.
	evt hand releaseMouseFocus: self.
	Cursor normal show. 
! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:25'!
click: evt
    super mouseDown: evt! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 6/11/2007 11:27'!
drawOn: aCanvas
	super drawOn: aCanvas. 
	
    dropOn ifNotNil: ["self halt."self highlightOn: aCanvas].! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 6/11/2007 11:39'!
highlightOn: aCanvas
	| topLeft drawBounds |
	topLeft := self topLeft x @ (self topLeft y + 1).
	drawBounds := topLeft extent: self width @ (self height + 1).
	drawBounds := drawBounds intersect: self bounds.
	aCanvas frameRectangle: self innerBounds width: 1 color: Color blue! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:26'!
mouseDown: evt
	| selectors |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].

	selectors _ Array 
		with: #click:
		with: nil
		with: nil
		with: #startDrag:.
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:34'!
mouseEnterDragging: evt
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseEnterDragging: evt].
	
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt)
		ifTrue: [
			dropOn := true.
			
			evt hand newMouseFocus: self.
			"test ifNil: [test := (evt hand firstSubmorph passenger == model). ""evt hand firstSubmorph passenger insertAfter: model."
				
			self changed.
		].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:16'!
mouseLeaveDragging: evt.
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseLeaveDragging: evt].
	self resetDropOn.
	evt hand releaseMouseFocus: self.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 16:21'!
mouseMove: evt
		
	"self = (self rowAtLocation: evt position) ifTrue: [^self]." 
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseMove: evt].
		
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) ifTrue: [self mouseEnterDragging: evt].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:18'!
resetDropOn
    dropOn ifNotNil: [dropOn := nil. self changed].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:54'!
startDrag: evt 
	| ddm |
	evt hand hasSubmorphs ifTrue: [^self].

	[  (self dragEnabled and: [model okToChange]) ifFalse: [^self].
	   ddm := TransferMorph withPassenger: model from: self.
        evt hand grabMorph: ddm]
	ensure: [Cursor normal show. evt hand releaseMouseFocus: self]! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:33'!
wantsDroppedMorph: transferMorph event: evt
	(transferMorph isKindOf: TransferMorph) ifFalse: [^false].
	(transferMorph passenger isKindOf: model class) ifFalse: [^false]. 
	transferMorph passenger == model ifTrue: [^false].
	
     ^true! !

OBDefinitionPanel subclass: #OBClosableDefinitionPanel
	instanceVariableNames: 'node morph isPinned owner contentMorph codeTabPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/8/2007 15:54'!
asDraggableMorph
	^(StringMorph contents: '*')
		color: Color white;
		yourself! !

!OBClosableDefinitionPanel methodsFor: 'building' stamp: 'dr 7/18/2007 15:25'!
buildOn: aBuilder
    morph ifNil: [morph := aBuilder closableDefinitionPanel: self with: []].
    ^morph! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 12/6/2007 11:48'!
changeToSourceCodePanel
    self exchangeContentWith: self createContentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 7/23/2007 14:41'!
changed
    (self respondsTo: #codeTabPanel) ifTrue: [
	     self codeTabPanel selection = 1 ifFalse: [self codeTabPanel selection: 1]].! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
classLabel
	| classLabel |
	classLabel := self className.
	self node ifNotNil: [self node isMethodHolderNode ifTrue: [classLabel := classLabel,' >>']].
	^classLabel! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
className
     ^self methodClass ifNotNil: [self methodClass name] ifNil: ['']! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
close
   browser definitionPanel panels size < 2 ifTrue: [^self inform: 'You cannot close the last panel.'].
   browser definitionPanel removePanel: self column: nil.! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
closeLabel
	^ (StringMorph 
		contents: 'x'
		font: ("TextStyle defaultFont" StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:49'!
color
	^browser defaultBackgroundColor ! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:45'!
commands
	| myNode |
	myNode _ self currentNode.
	myNode ifNil: [^ #()].
     ^{OBCmdSystemComplexity on: myNode for: self. OBCmdUmlDiagram on: myNode for: self}
    ! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/12/2007 13:55'!
createClassLabel
	| classLabel |		
     classLabel := (StringMorph 
		contents: (Text string: self classLabel attribute: TextEmphasis bold)	
		font: (StrikeFontSet familyName: #NewYork size: 10))
			color: Color black;
			yourself.
	classLabel on: #mouseDown send: #selectClass to: self.			
	classLabel hResizing: #spaceFill; vResizing: #spaceFill; setWidth: 100; height: 20.						
			
	^classLabel		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/5/2007 17:45'!
createCloseButton						
	^PluggableButtonMorph
		on: self
		getState: #isSelected
		action: #close
		label: #closeLabel.! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 11/19/2007 10:26'!
createContentMorph
	| textEditor shoutInstalled morphClass |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	morphClass := shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].	
	textEditor := (morphClass
		on: self
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		font: Preferences standardCodeFont;
		yourself.
	textEditor 
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		color: Color white.
     ^textEditor! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/12/2007 15:20'!
createDragButton
	| dragButton paneColor |
	dragButton := OBDraggableButtonMorph 
				on: self
				getState: #isDragged
				action: #drag
				label: #dragLabel.
	dragButton enableDragNDrop.
	paneColor := browser defaultBackgroundColor.
	dragButton onColor: Color lightGray lighter offColor: paneColor.
	^ dragButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/19/2007 14:05'!
createMorph			
     morph := nil.						
	^self buildOn: OBMorphBuilder new		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/12/2007 15:20'!
createPinButton
	| pinButton paneColor |
	pinButton := OBDraggableButtonMorph 
				on: self
				getState: #isPinned
				action: #pin
				label: #pinLabel.
	paneColor := browser defaultBackgroundColor.
	pinButton onColor: Color lightGray lighter offColor: paneColor.
	^ pinButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/11/2007 11:48'!
createTitleBar
	| titleBar |		
	titleBar := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		"borderColor: Color black;"
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
			
	titleBar addMorphBack: self createClassLabel; 
	          addMorphBack: self createDragButton; 
	          addMorphBack: self createPinButton; 
	          addMorphBack: self createCloseButton.			
	^titleBar		! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 15:50'!
currentNode
    ^self node ifNil: [super currentNode]! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
    ^self node ifNil: [super currentOrRootNode]! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:47'!
drag
    "do nothing"! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:49'!
dragLabel
	^ (StringMorph 
		contents: '<- ->'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:43'!
dropMorph: aMorph
    | panelToBeMoved |
    panelToBeMoved := aMorph passenger.

    (self isPlacedBefore: panelToBeMoved) ifTrue: [
	   panelToBeMoved insertBefore: self. 
    ] ifFalse: [
        panelToBeMoved insertAfter: self.
    ].! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/29/2007 15:34'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/20/2007 11:40'!
getDefinition
     definition ifNotNil: [^definition].
	^ browser currentNode ifNotNilDo: [:ea | ea definition]! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 7/18/2007 15:32'!
hasSeveralPanels	
	^browser definitionPanel panels size > 1! !

!OBClosableDefinitionPanel methodsFor: 'initializing' stamp: 'dr 6/7/2007 11:20'!
initialize
    isPinned := false! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:33'!
insertAfter: aPanel
    ^self owner insert: self after: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:44'!
insertBefore: aPanel
    ^self owner insert: self before: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
isChangeable
    ^self isPinned not! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/11/2007 11:47'!
isDragged
    ^false! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/6/2007 15:59'!
isPinned
    ^isPinned! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:35'!
isPlacedBefore: aClosableDefinitionPanel
    ^self owner is: self placedBefore: aClosableDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
isSelected
    ^false
   ! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
methodClass
     ^(self node respondsTo: #theClass) ifTrue: [self node theClass] ifFalse: [nil]! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/18/2007 15:41'!
morph
	^morph
! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 11:45'!
node
    ^node! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/29/2007 15:15'!
node: aNode
    node := aNode. 
    "self selectSourceTab."! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner
	^owner! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner: aMultipleDefinitionPanel
	owner := aMultipleDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/7/2007 11:50'!
pin
    self isPinned ifTrue: [isPinned := false] ifFalse: [isPinned := true] ! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/6/2007 15:20'!
pinLabel
	^ (StringMorph 
		contents: '!!'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
selectClass
    browser jumpTo: (OBClassNode on: self methodClass)! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/29/2007 16:31'!
selectSourceTab
    self exchangeContentWith: self createContentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'updating' stamp: 'dr 7/20/2007 11:11'!
selectionChanged: ann
	self definition: self getDefinition! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/18/2007 15:35'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/6/2007 15:59'!
setIsPinned
    isPinned := true! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 11/19/2007 10:56'!
shoutAboutToStyle: aPluggableShoutMorph
	|  myNode classOrMetaClass |

	myNode := self currentNode.
	((myNode isKindOf: OBMethodNode) or: [(myNode isKindOf: OBMethodVersionNode) or:[myNode isKindOf: OBMethodCategoryNode]])
		ifTrue:[
			classOrMetaClass := myNode theClass.
			(classOrMetaClass isBehavior or:[classOrMetaClass isTrait]) ifFalse:[classOrMetaClass := nil].
			aPluggableShoutMorph classOrMetaClass: classOrMetaClass. 
			^true].
	(((myNode isKindOf: OBClassNode) or: [(myNode isKindOf: OBClassCategoryNode)]) or: [(myNode isKindOf: OBMonticelloPackageNode)]) 
		ifTrue:[
			aPluggableShoutMorph classOrMetaClass: nil.
			^true].
	^false! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:19'!
swapWith: aPanel
    ^self owner swap: self with: aPanel! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 15:39'!
currentNode
	^browser currentNode! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
	^browser currentOrRootNode! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 11:16'!
isDefinition
    ^true! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 15:39'!
node
	^nil! !

OBDefinitionPanel subclass: #OBMondrianPanel
	instanceVariableNames: 'visualization contentMorph node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/3/2007 14:58'!
classBlueprint
    self setVisualization: #classBlueprint.
    ^self morph! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/12/2007 13:30'!
createClassBlueprint
	| view theClass |
	theClass := self currentNode theClass.
	view := MOClassBlueprint ofClass: theClass inPanel: self.
	^self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/22/2007 14:41'!
createContentMorph
    ^self perform: ('create', visualization asString capitalized) asSymbol
! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/22/2007 15:00'!
createContentMorphWithView: aView
    contentMorph := ScrollPane new
          borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

    contentMorph scroller addMorph: (MOViewer on: aView graph).
    ^contentMorph
! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/3/2007 10:37'!
createSystemComplexity
    ^self createContentMorphWithView: (MOPainting createSystemComplexityOf: self currentNode theClass)! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 7/3/2007 10:57'!
createUmlDiagram
	| view theClass |
	theClass := self currentNode theClass.
	view := MORenderer new.
	view layout: ((MOVerticalSpacedTreeLayout new)
				gap: [:ea | 10 @ 40];
				roots: [:each | Array with: (view elementOf: theClass)];
				children: [:each | each subclasses collect: [:ea | view elementOf: ea]]).
	view style: MOUmlClass new.
	view addAll: theClass withAllSubclasses.
	view layout: ((MOConnectorLayout new)
				source: [:each | view graph elementOf: each model key];
				sourcePosition: #topCenter;
				target: [:each | view graph elementOf: each model value];
				targetPosition: #bottomCenter).
	view style: MOUmlInheritance new.
	view 
		addAll: (theClass allSubclasses collect: [:each | each -> each superclass]).
	^ self createContentMorphWithView: view! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:24'!
currentNode
    ^self node ifNil: [super currentNode]! !

!OBMondrianPanel methodsFor: 'initializing' stamp: 'dr 6/22/2007 15:00'!
initialize
    super initialize.
    visualization := #systemComplexity! !

!OBMondrianPanel methodsFor: 'morphic' stamp: 'dr 6/29/2007 14:40'!
morph
    ^self createContentMorph! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:21'!
node
	^node! !

!OBMondrianPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 15:21'!
node: aNode
	node := aNode! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/22/2007 14:38'!
setVisualization: aSymbol
    visualization := aSymbol! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/29/2007 14:46'!
systemComplexity
    self setVisualization: #systemComplexity.
    ^self morph! !

!OBMondrianPanel methodsFor: 'visualizations' stamp: 'dr 6/29/2007 14:46'!
umlDiagram
	self setVisualization: #umlDiagram.
	^self morph! !
OBSmartRootNode initialize!
OBMultipleSelectionBrowserAdaptor initialize!
OBPackageBrowserAdaptor initialize!
OBMultipleSelectionBrowser initialize!
OBSmartGroupBrowser initialize!
